#!/bin/sh

# Licensed Materials - Property of IBM
# 5648-AE1  
# (c) Copyright IBM Corp. 2014,2016.
# Version:1.21

#sanity check
VALID='^[a-zA-Z_0-9\&\=]+$'
if !([[ $QUERY_STRING =~ $VALID ]]); then
echo "Content-type: text/html"
echo ""
echo "<html><head><title>Notification</title></head><body>"
echo "Input parameters incorrect"
echo "</body></html>"
exit
fi

# extract the serverID from the query
serverID=`echo "$QUERY_STRING" | grep -oE "(^|[?&])guestName=[^&]+" | cut -f 2 -d "="| head -n1`
serverID=${serverID:0:8}

# extract systemID
sysID=`echo "$QUERY_STRING" | grep -oE "(^|[?&])sysName=[^&]+" | cut -f 2 -d "="| sed "s/%20/ /g"| head -n1`
sysID=${sysID:0:8}

# run query
CLICommand=`/usr/wave/WAVECLI/CGIScript/wavecli.scr signalActivationDone $sysID.$serverID| grep 'run RC'`
# get return RC
CLICommand=${CLICommand:28:4}
# output to user
echo "Content-type: text/html"
echo ""
echo "<html><head><title>Notification</title></head><body>"
echo "Sending notification to $sysID.$serverID <br>"
echo "result is $CLICommand"
echo "</body></html>"