#!/bin/bash

# Licensed Materials - Property of IBM
# 5648-AE1  
# (c) Copyright IBM Corp. 2014, 2015, 2016.





NEWVERSION='120'
NEWVERSIONWITHDOT='1.2.0'
GA2_SP0_RPM_MD5='c0e5246cf40844d4cf372fc98a9a5dbb'
myCnfPostSuffix=".PostGA2SP5"
MY_CNF_GA2_SP5_VER=1206
shouldInstallRPM=false
deltaRPMName=IBM-Wave-1.20-1.s390x.deltarpm
newRPMPath=/tmp/IBM-Wave-1.20-1.s390x.temp.rpm
updateWave=false ; updateCommon=false ;updateBackground=false;updateDBRestorer=false;updateEncKey=false;updateCLI=false
updateWebScript=false;updateWaveJnlp=false;updateBackgroundServices=false;updateTestJnlp=false;updatePassResetter=false
updateTestAPI=false;updateIndex=false;updateStyle=false;updateExecNotification=false;updateWaveSrvIP=false;updateVersionScript=false
updateServerConf=false;updateHttpd=false;updateHttpdRh5=false;updateHttpdRh6=false;updateLoadClc=false;updateLogRotate=false;updateMyCnf=false
updateMyCnfRh=false;updateWaveCron=false;updateInternalExecutor=false;updateDBRestoreScript=false;updateEncryptChanger=false;updatePassResetterScript=false
updateNetworkUpdate=false;updatePackWaveCLI=false;updateCLIBat=false;updateCLIScr=false;updateSM=false;updateDataCapture=false;updateDataCaptureScript=false;updateLic=false
updateSpecFiles=false;migration=false;
updateApacheCommon=false; updateJsch=false; update=false
updateConnectableExit=false;
updateMyCnfPostGA2SP5=false;
updateMyCnfRhPostGA2SP5=false;
updateWAVEToolsScript=false;
updateWAVETools=false;
unset DISPLAY

tables=("AGC_Entry_Table" "BTS_Request_Statistics_Table" "BTS_Request_Table" 
"BTS_Schedule_Table" "BTS_Workunit_Table" "COR_Entry_Log_Active_Table" "COR_Entry_Table" 
"FCP_Connection_Table" "FCP_Disk_Table" "FCP_WWPN_SC_Table" "Linux_Repository_Table" 
"OS_Distribution_Table" "Site_Project_Table" "VM_Account_Table" "VM_CPC_Table" 
"VM_DASD_Group_Common_Table" "VM_DASD_Group_Specific_Table" 
"VM_DASD_Region_Common_Table" "VM_DASD_Region_Group_Relation_Table" 
"VM_DASD_Region_Specific_Table" "VM_DASD_Volume_Table" "VM_Directory_Table" 
"VM_Performance_Table" "VM_Profile_Common_Table" "VM_Profile_Specific_Table" 
"VM_Prototype_Common_Table" "VM_Prototype_Specific_Table" "VM_System_Table" 
"VM_User_Common_Table" "VM_User_Group_Table" "VM_User_Specific_Table" 
"VM_Workunit_Table" "WAVE_Attention_Required_Table" "WAVE_Custom_Attribute_Table" 
"WAVE_External_Call_Messages" "WAVE_External_Resource_Messages_Detailed_US" 
"WAVE_External_Resource_Messages_Short_US" "WAVE_LOG" "WAVE_Managed_Entity_Connection_Table" 
"WAVE_Managed_Entity_Table" "WAVE_Messages" "WAVE_Parameter_Table" "WAVE_Personalization_Table" 
"WAVE_Script_Template_Table" "WAVE_User_Group_Table" "WAVE_User_Permission_Table" 
"WAVE_User_Profile_LDAP_Group_Table" "WAVE_User_Profile_Table" 
"WAVE_User_Profile_User_Table" "WAVE_User_Script_Table" "WAVE_User_Table" 
"WAVE_VM_Update_Table" "WAVE_Virtual_Network_Segment_Relation_Table" 
"WAVE_Virtual_Network_Segment_Table" "WAVE_WRS_Table" "WAVE_Workunit_Table" 
"zVM_Device_Pool_Association_Table" "zVM_Device_Pool_Table" "zVM_Guest_LAN_Table" 
"zVM_Real_Device_Dedicate_Link_Table" "zVM_Real_Device_Table" "zVM_Unique_ID_Table" 
"zVM_VSwitch_Table" "zVM_Virtual_Network_Connection_Table" )

#generic Services names
GENERIC_SRV_NAME_MYSQL_SERVER=mysql-server
GENERIC_SRV_NAME_NFS_SERVER=nfs-server
GENERIC_SRV_NAME_WEB_SERVER=web-server





function logMessage() {
  echo "$@"
}
function logToFileOnly(){
	echo "$@">>$logFile
}

#Function which returns the correct service name per distribution
function getServiceNameForDistro() {
	#expecting to get
    #GENERIC_SRV_NAME_MYSQL_SERVER
    #GENERIC_SRV_NAME_NFS_SERVER
    #GENERIC_SRV_NAME_WEB_SERVER
    genericName=$1
    serviceName=""
    if [ "$genericName" == "$GENERIC_SRV_NAME_MYSQL_SERVER" ]; then
        if [ "$distro" == "rhel" ]; then
            if [ "$level" == "7" ]; then
                serviceName=mariadb
            else
                serviceName=mysqld
            fi
        elif [ "$distro" == "suse" ]; then
            serviceName=mysql
        fi
    elif [ "$genericName" == "$GENERIC_SRV_NAME_NFS_SERVER" ]; then
        if [ "$distro" == "rhel" ]; then
            if [ "$level" == "7" ]; then
                serviceName=nfs-server
            else
                serviceName=nfs
            fi
        elif [ "$distro" == "suse" ]; then
            serviceName=nfsserver
        fi
    elif [ "$genericName" == "$GENERIC_SRV_NAME_WEB_SERVER" ]; then
        if [ "$distro" == "rhel" ]; then
                serviceName=httpd
        elif [ "$distro" == "suse" ]; then
            serviceName=apache2
        fi
    fi
}

#Function to set the current OS the server is installed on, updating requires moving files to different locations per distro
function getOS() {
	if test -f /etc/os-release; then
		distro=`cat /etc/os-release | grep "^ID=" | cut -d'=' -f2 | tr -d '"' | tr "[:upper:]" "[:lower:]"`
		if [ "$distro" == "sles" ]; then
			distro="suse"
			dbDistro="SLES"
		elif [ "$distro" == "rhel" ]; then 
			dbDistro="RHEL"
		fi
		# the VERSION_ID parameter can only have  0-9, a-z, ".", "_" and "-". 
		# As it is not clear how SLES will show the SP1 in VERSION_ID we are trying to split by ".","_" and "-" 
		# to try and make this code work on next SP as well 
		level=`cat /etc/os-release | grep "^VERSION_ID=" | cut -d'=' -f2 | tr -d '"' | cut -d"." -f1 | cut -d"_" -f1 | cut -d"-" -f1`
		# as it is not clear how SLES will show the SP1 in VERSION_ID we will ignore it for now as we don't need it.
		patchLevel=0	
	elif [ -f /etc/SuSE-release ]; then
    	distro="suse"
    	dbDistro="SLES"
		#Check to see if a secod release file for rhel exists, if it does installer will cancel
		if [ -f /etc/redhat-release ]; then
			logMessage "Two distro release files detected in /etc. Could not determine OS"
			exit 1
		fi
			
    	level=$(cat /etc/SuSE-release | grep "VERSION = [0-9]\+" | grep -o "[0-9]\+")
    	patchLevel=$( cat /etc/SuSE-release | grep "PATCHLEVEL = [0-9]\+" | grep -o "[0-9]\+")
     
     elif [ -f /etc/redhat-release ]; then
		if [ -f /etc/SuSE-release ]; then
			logMessage "Two distro release files detected in /etc. Could not determine OS"
			exit 1
		fi
	
    		a=`grep -i 'red.*hat.*enterprise.*linux' /etc/redhat-release`
    	if test $? = 0; then
        	 	distro=rhel
        	 	dbDistro="RHEL"
    	fi
        fullVersion=$( cat /etc/redhat-release  |grep -o "[0-9]\+.[0-9]\+")
        level=$(echo "$fullVersion" |cut -f1 -d ".")
        patchLevel=$(echo "$fullVersion" |cut -f2 -d ".")
        
	else 
		logMessage "Unsupported Operating System found, exiting.."
		exit 1
fi	
	if [ "$patchLevel" == "0" ]; then
        logMessage "Detected $distro-$level"
    else
        logMessage "Detected $distro-$level.$patchLevel"
    fi
    archName=$(uname -m)
    if [ "$archName" = "s390" ]; then
    	arch="32b"
    else
    	arch="64b"
    fi
}

CURRDATE=$(date +%F-%T)
##Change :s in timestamp to -s can not extract directories which contain a
# : special character.
CURRDATE=${CURRDATE//:/-}
# if doUpdate.sh is being run before the RPM is installed (with the -i option) the directory might not exist
if ! [ -d "/var/log/WAVE" ]; then
	mkdir -p /var/log/WAVE
fi
logFile='/var/log/WAVE/updateLog-'$CURRDATE
BACKUP_DIR_NAME=backup-$CURRDATE
BACKUP_DIR="/usr/wave/$BACKUP_DIR_NAME"
BASEDIR='/usr/wave'
#Directory the script (and therefore the files to be copied) are located in
runDir="$( cd "$( dirname "$0" )" && pwd )"


#Return stdout and stderr to the normal mode
function returnStdOutToNormal(){
	exec >&3 2>&4
}

#This is a trap function to release the stdout 
#The function to execute on trap
function final(){
	returnStdOutToNormal
}
#register traps for exit and kill of process ,ERR for errors , maybe used later
trap final EXIT SIGINT SIGQUIT SIGABRT SIGTERM 

#Save the stdout and stderr to file descriptor and redirect to log file
function saveAndRedirectStdOutToFileDescriptor(){
	exec 3>&1 4>&2
	exec &> >(tee -ia $logFile)
}


saveAndRedirectStdOutToFileDescriptor
getOS
if ([ "$distro" == "rhel" ] && [ "$level" == "7" ]) || ([ "$distro" == "suse" ] && [ "$level" == "12" ]); then
    # there can be more than one 127.0.0.x addresses in the output of ip addr. remove them all
    IP_ADDRESS=$(ip addr | grep 'inet '| grep -v '127.0.0.' -m 1 | cut -d'/' -f1 | awk '{ print $2}')
else
    IP_ADDRESS=$(ifconfig  | grep 'inet addr:'| grep -v '127.0.0.1' -m 1 | cut -d: -f2 |
awk '{ print $1}')	
fi

#converts BTS build number to determine 
#what fix pack it correspons to
#
#Input: BTS build level (e.g. 503). 
#
#Echo Output: The fix pack number.  (e.g. An input of 503 would have an output of 3)
#	If input is unrecognized, this function will echo -1
function getFixPackNumber() {
	buildLevel=$1
	
	if (( $buildLevel > 503 ));then
		echo 4
		return
	fi
	
	case $buildLevel in
		503)
			echo 3
			;;
		*)
			echo -1
	esac
}

#Uses regex to pull versions from Jars, first argument passed to the function is the wave basedir to check for versions,
#Second argument is used to prepend "update" to the variables so we can compare the installed versions to update versions later
#Also sets jar paths, because jar versions in the name may be different
function setCurrentVersions() {
	
	# set Local paths
	waveJarLocale="$BASEDIR/GUI/appl/WAVE$NEWVERSION.jar"
	backgroundJarLocale="$BASEDIR/WAVEBackground/WAVEBackground$NEWVERSION.jar"
	testApiJarLocale="$BASEDIR/GUI/TestAPI/TestAppl.jar"
	DBRestoreJarLocale="$BASEDIR/WAVEBackground/WAVEDBRestorer$NEWVERSION.jar"
	WAVEToolsJarLocale="$BASEDIR/WAVEBackground/WAVETools$NEWVERSION.jar"
	encKeyJarLocale="$BASEDIR/WAVEBackground/WAVEEncKeyChanger$NEWVERSION.jar"
	waveCLIJarLocale="$BASEDIR/WAVECLI/WAVECLI$NEWVERSION.jar"
	passResetterJarLocale="$BASEDIR/WAVEBackground/PasswordResetter.jar"
	dataCaptureJar=$(ls $BASEDIR/WAVEBackground/WAVEDataCapture$NEWVERSION.jar)
	commonJarLocale="$BASEDIR/GUI/Common/WAVECommon$NEWVERSION.jar"
	
	# extract full application version
	verInfo=$(java -cp $commonJarLocale com.CSL.WAVE.versionInfo.CommonsBuildStringGen -version)
	commonVer=$(echo $verInfo |grep -Eo "Version [0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}" |grep -Eo "[0-9]\.[0-9]\.[0-9]"|tr -d '.')
	fixPackInfo=$(java -cp $commonJarLocale com.CSL.WAVE.versionInfo.CommonsBuildStringGen -fixpack)
	
	# Fix Pack doesn't exists for older WAVE versions, so set it to 0
	if [[ "$fixPackInfo" == *"error"* ]];then
		fixPackInfo=0;
	fi
	fullApplicationVersionLocal="$commonVer.$fixPackInfo"
	
	#WaveDB not checked for update
	#waveDBVer=$(grep -E "WAVEDB_Version" $BACKUPDIR/WAVEDBDump.sql |grep -Eo "[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}" |tr -d '.')
	
	#Script was added post GA, so need to handle possiblility of script not existing on waveserver
	if [ ! -e $BASEDIR/WAVEBackground/WAVEDataCapture ];then
		dataCaptureScriptVer="0"
	else	
		dataCaptureScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVEBackground/WAVEDataCapture |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	fi
	
	webScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/GUI/scripts.js |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')	
	waveJnlpVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/GUI/WAVE.jnlp |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	waveBackgroundServicesVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVEBackground/WAVEBackgroundServices |grep -Eo "[0-9]\.[0-9]{2}" |tr -d '.')
	testApiJnlpVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/GUI/TestAPI.jnlp |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	
	indexVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/GUI/index.html |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	styleVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/GUI/style.css |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	execNotificationVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/GUI/CLI/execNotification.cgi |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	changeWaveSrvIpVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/changeWAVESRVIP.sh |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	versionScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/IBM-Wave-Ver.scr |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	defaultServerVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/default-server.conf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	httpdVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/httpd.conf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	httpdRh5Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/httpd.conf.rhel5 |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	httpdRh6Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/httpd.conf.rhel6 |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	#loadClcVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/loadCLC.scr |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	logRotateVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/logrotate.conf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	myCnfAtEtcVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" /etc/my.cnf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	myCnfVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/my.cnf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	myCnfRhVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/my.cnf.rh |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	myCnfPostGA2SP5Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/my.cnf$myCnfPostSuffix |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	myCnfRhPostGA2SP5Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/my.cnf.rh$myCnfPostSuffix |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	waveCronVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/WAVE.cron |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	internalExecutorVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/scripts/WAVEInternal.WAVE_Executor |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	dbRestoreScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVEBackground/WAVEDBRestorer |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	WAVEToolsScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVEBackground/WAVETools |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	encryptChangerVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVEBackground/WAVEEncryptChanger |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	passResetterScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVEBackground/WAVEPasswordResetter |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	networkUpdateVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVECLI/networkUpdate.scr |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	packWaveCliVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVECLI/packWAVECLI |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	cliBatVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVECLI/wavecli.bat |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	cliScrVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/WAVECLI/wavecli.scr |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	sm191Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/install/smVer |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	licVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/doc/license/licVer |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	specVer=$(rpm -q --scripts IBM-Wave |grep -Eo "Revision: [0-9]{1,2}\.[0-9]{1,3}" |grep -Eo "[0-9]{1,2}\.[0-9]{1,3}" |tr -d '.')
	connectableExitVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $BASEDIR/exit/WaveConnectableGuestsExit.samp |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	#logging
	logMessage "Installed Build Levels"
	logMessage "Fix Pack: $fixPackInfo"
}
		

#queries the rpm level installed, if the rpm level installed is 1.10 (GA1), then the migration flag is set
function queryRpmSetMigrationFlag(){
  installedRPMLevel=$(rpm -qa IBM-Wave |grep -Eo "[0-9]\.[0-9]{2}")
  if [[ "$installedRPMLevel" == "1.10" ]];then
    migration=true
  fi
}

#Sets Versions found in update package
function setUpdateVersions() {
	
	echo "Set updated version"
	
	# Set update paths
	updateWaveJar=$(ls $runDir/GUI/appl/WAVE$NEWVERSION.jar)
	updateCommonJar=$(ls $runDir/GUI/Common/WAVECommon$NEWVERSION.jar)
	updateBackgroundJar=$(ls $runDir/WAVEBackground/WAVEBackground$NEWVERSION.jar)
	updateTestApiJar=$(ls $runDir/GUI/TestAPI/TestAppl.jar)
	updateDBRestoreJar=$(ls $runDir/WAVEBackground/WAVEDBRestorer$NEWVERSION.jar)
	updateWAVEToolsJar=$(ls $runDir/WAVEBackground/WAVETools$NEWVERSION.jar)
	updateEncKeyJar=$(ls $runDir/WAVEBackground/WAVEEncKeyChanger$NEWVERSION.jar)
	updateWaveCLIJar=$(ls $runDir/WAVECLI/WAVECLI$NEWVERSION.jar)
	updatePassResetterJar=$(ls $runDir/WAVEBackground/PasswordResetter.jar)
	updateDataCaptureJar=$(ls $runDir/WAVEBackground/WAVEDataCapture$NEWVERSION.jar)
	updateCommonJar=$(ls $runDir/GUI/Common/WAVECommon$NEWVERSION.jar)
	
	# Extract full application version
	verInfo=$(java -cp $updateCommonJar com.CSL.WAVE.versionInfo.CommonsBuildStringGen -version)
	updateCommonVer=$(echo $verInfo |grep -Eo "Version [0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}" |grep -Eo "[0-9]\.[0-9]\.[0-9]"|tr -d '.')
	fixPackInfo=$(java -cp $updateCommonJar com.CSL.WAVE.versionInfo.CommonsBuildStringGen -fixpack)
	fullApplicationVersionUpdate="$updateCommonVer.$fixPackInfo"
	

	#Greps out WAVEDB_Version from WAVEDBDump.sql in backup dir(created when backing files up) to determine db version
	#updateWaveDBVer=$(grep -E "WAVEDB_Version" $runDir/install/WAVEDBDump.sql |grep -Eo "[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}" |tr -d '.')

	updateDataCaptureScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVEBackground/WAVEDataCapture |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateWebScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/GUI/scripts.js |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateWaveJnlpVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/GUI/WAVE.jnlp |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateWaveBackgroundServicesVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVEBackground/WAVEBackgroundServices |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateTestApiJnlpVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/GUI/TestAPI.jnlp |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	
	updateIndexVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/GUI/index.html |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateStyleVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/GUI/style.css |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateExecNotificationVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/GUI/CLI/execNotification.cgi |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateChangeWaveSrvIpVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/changeWAVESRVIP.sh |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateVersionScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/IBM-Wave-Ver.scr |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateDefaultServerVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/default-server.conf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateHttpdVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/httpd.conf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateHttpdRh5Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/httpd.conf.rhel5 |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateHttpdRh6Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/httpd.conf.rhel6 |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	#update LoadCLC should no longer be checked, removed from GA2.
	#updateLoadClcVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/loadCLC.scr |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	
	updateLogRotateVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/logrotate.conf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateMyCnfVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/my.cnf |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateMyCnfRhVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/my.cnf.rh |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateMyCnfPostGA2SP5Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/my.cnf$myCnfPostSuffix |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateMyCnfRhPostGA2SP5Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/my.cnf.rh$myCnfPostSuffix |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateWaveCronVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/WAVE.cron |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateInternalExecutorVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/scripts/WAVEInternal.WAVE_Executor |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateDbRestoreScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVEBackground/WAVEDBRestorer |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateWAVEToolsScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVEBackground/WAVETools |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateEncryptChangerVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVEBackground/WAVEEncryptChanger |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updatePassResetterScriptVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVEBackground/WAVEPasswordResetter |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateNetworkUpdateVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVECLI/networkUpdate.scr |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updatePackWaveCliVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVECLI/packWAVECLI |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateCliBatVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVECLI/wavecli.bat |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateCliScrVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/WAVECLI/wavecli.scr |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateSm191Ver=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/install/smVer |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateLicVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/doc/license/licVer |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')
	updateSpecVer=$(rpm -qp --scripts $runDir/install/IBM-Wave-*.upgrade.s390x.rpm |grep -Eo "Revision: [0-9]{1,2}\.[0-9]{1,3}" |grep -Eo "[0-9]{1,2}\.[0-9]{1,3}" |tr -d '.')
	updateConnectableExitVer=$(grep -Eo "Version:[0-9]{1,2}\.[0-9]{2,3}" $runDir/exit/WaveConnectableGuestsExit.samp |grep -Eo "[0-9]{1,2}\.[0-9]{2,3}" |tr -d '.')

    
	#logging
	#echo "Updater Build Levels" >>logFile
	#echo "updateWaveBuild:$updateWaveBuild" >>logFile;echo "updateCommonBuild:$updateCommonBuild" >>logFile;echo "updateBackgroundBuild:$updateBackgroundBuild>>logFile";echo "updateTestAPIBuild:$updateTestApiBuild">>logFile; echo "updateDBRestoreBuild:$DBRestoreBuild">>logFile
	#echo "updateEncKeyBuild:$updateEncKeyBuild">>logFile;echo "updateWaveCLIBuild:$updateWaveCLIBuild">>logFile; echo "updatePassResetterBuild:$updatePassResetterBuild">>logFile;
}

#Function to compare two decimal separated version number strings and return the
#most recent version string of the pair
function compareVersionStrings () {   
    
    newestVersion=""
    if [ "$1" == "$2" ]; then
	    newestVersion="$1"
	else
		# Attempt to use sort -V.  If its not installed, we'll need to sort manually
	    if [ -e `sort -V /dev/null 2> /dev/null || { echo '0'; }` ]; then
	    	newestVersion=`echo -e "$1\n$2" | sort -V | tail -n1`
	    else
	    	# We want to pad version1 and version2 to have the same number of decimal-
	    	# separated fields
			str1=$1	str1NumFields=`echo "$1" | tr '.' '\n' | wc -l`
			str2=$2	str2NumFields=`echo "$2" | tr '.' '\n' | wc -l`
			arrayLength="$str2NumFields"
			if [ $str1NumFields -ne $str2NumFields ]; then
				if [ $str1NumFields -lt $str2NumFields ]; then
					# arrayLength=$str2NumFields
					for ((i=$str1NumFields; i<$str2NumFields; i++)); do
		        		str1="$str1.0"
		    		done
				else
					arrayLength=$str1NumFields
					for ((i=$str2NumFields; i<$str1NumFields; i++)); do
		        		str2="$str2.0"
		    		done
		    	fi
		    fi
		    
			# Tokenize both strings into arrays
			IFS=.
			str1Array=($str1)
			str2Array=($str2)
			IFS= 
	    	
	    	# Traverse the arrays from left-to-right, comparing each element of str1Array
			# to each element of str2Array.  If at any point the element in one array
			# is larger than its counterpart, that version must be the larger of the two.
			index=0
	    	while [ "$index" -lt "$arrayLength" ]; do
				if [ ${str1Array[index]} -ne ${str2Array[index]} ]; then
					if [ ${str1Array[index]} -gt ${str2Array[index]} ]; then
						newestVersion="$1"
						break
					else
						newestVersion="$2"
						break
					fi
				fi
				let "index+=1"
			done
	    fi
	fi
	
	echo "$newestVersion"
}

#compares currently installed build levels to the build levels in upgrade pack
function compareVersions() {
	if test -f /usr/wave/GUI/Common/commons-collections-3.2.jar; then
       updateApacheCommon=true
	fi

	# verify if the JSCH jar needs to be updated
	if [ -f /usr/wave/GUI/Common/jsch-0.1.42.jar ] || [ -f /usr/wave/GUI/appl/jsch-0.1.42.jar ]; then
		updateJsch=true
	fi
	
	# compare the versions and service packs
	IFS=.; read -r -a localVerArray <<< "$fullApplicationVersionLocal"; unset IFS
	IFS=.; read -r -a updateVerArray <<< "$fullApplicationVersionUpdate"; unset IFS
	
	LEN1=${#localVerArray[@]}
	LEN2=${#updateVerArray[@]}
	
	if [ $LEN1 -gt $LEN2 ]; then
		N=`expr $LEN1 - $LEN2`
		for (( i=0; i<$N; i++ ))
		do
			updateVerArray=("${updateVerArray[@]}" "0")	
		done
	
	else
		N=`expr $LEN2 - $LEN1`
		for (( i=0; i<$N; i++ ))
		do	
			localVerArray=("${localVerArray[@]}" "0")	
		done
	
	fi

	shouldUpdateJars=0;

	for (( i=0; i<${#localVerArray[@]}; i++ ))
	do
		if [ ${localVerArray[i]} -lt ${updateVerArray[i]} ]
		then
				shouldUpdateJars=1;
				break;
		elif [ ${localVerArray[i]} -gt ${updateVerArray[i]} ]
		then
				shouldUpdateJars=0;
				break;
		else
				shouldUpdateJars=1;
		fi
	done
	
	# update all jars if needed
	if [ $shouldUpdateJars -gt 0  ]; then
		updateWave=true
		updateCommon=true
		updateBackground=true
		updateDBRestorer=true
		updateEncKey=true
		updateCLI=true
		updatePassResetter=true
		updateTestAPI=true
		updateDataCapture=true;
		updateWAVETools=true 
	fi
	
	if [ -z $webScriptVer ]; then
		updateWebScript=true
	elif [ $webScriptVer -lt $updateWebScriptVer ]; then
		updateWebScript=true
	fi
	
	if [ -z $waveJnlpVer ]; then
		updateWaveJnlp=true
	elif [ $waveJnlpVer -lt $updateWaveJnlpVer ]; then
		updateWaveJnlp=true	
	fi
	
	if [ -z $waveBackgroundServicesVer ] || [ $waveBackgroundServicesVer -lt $updateWaveBackgroundServicesVer ]; then
		updateBackgroundServices=true
	fi

	if [ -z $testApiJnlpVer ] || [ $testApiJnlpVer -lt $updateTestApiJnlpVer ]; then
		updateTestJnlp=true
	fi
	
	if [ -z $indexVer ];then
		updateIndex=true
	elif [ $indexVer -lt $updateIndexVer ];then
		updateIndex=true
	fi
	
	if [ -z $styleVer ];then
		updateStyle=true
	elif [ $styleVer -lt $updateStyleVer ];then
		updateStyle=true
	fi
	
	if [ -z $execNotificationVer ];then
		updateExecNotification=true
	elif [ $execNotificationVer -lt $updateExecNotificationVer ];then
		updateExecNotification=true
	fi
			
	if [ -z $changeWaveSrvIpVer ];then
		updateWaveSrvIP=true
	elif [ $changeWaveSrvIpVer -lt $updateChangeWaveSrvIpVer ];then
		updateWaveSrvIP=true
	fi

	if [ -z $versionScriptVer ];then
		updateVersionScript=true
	elif [ $versionScriptVer -lt $updateVersionScriptVer ];then
		updateVersionScript=true
	fi

	if [ -z $defaultServerVer ];then
		updateServerConf=true
	elif [ $defaultServerVer -lt $updateDefaultServerVer ];then
		updateServerConf=true
	fi

	if [ -z $httpdVer ];then
		updateHttpd=true
	elif [ $httpdVer -lt $updateHttpdVer ];then
		updateHttpd=true
	fi
	
	if [ -z $httpdRh5Ver ];then
		updateHttpdRh5=true
	elif [ $httpdRh5Ver -lt $updateHttpdRh5Ver ];then
		updateHttpdRh5=true
	fi
	
	if [ -z $httpdRh6Ver ];then
		updateHttpdRh6=true
	elif [ $httpdRh6Ver -lt $updateHttpdRh6Ver ];then
		updateHttpdRh6=true
	fi
#
	#if [ ! -z $loadClcVer ];then
		#updateLoadClc=true	
	#fi
	
	if [ -z $logRotateVer ];then
		updateLogRotate=true
	elif [ $logRotateVer -lt $updateLogRotateVer ];then
		updateLogRotate=true
	fi

	if [ -z $myCnfVer ];then
		updateMyCnf=true
	elif  [ $myCnfVer -lt $updateMyCnfVer ];then
		updateMyCnf=true
	fi

	if [ -z $myCnfRhVer ];then
		updateMyCnfRh=true
	elif [ $myCnfRhVer -lt $updateMyCnfRhVer ];then
		updateMyCnfRh=true
	fi

	if [ -z $myCnfPostGA2SP5Ver ];then
		updateMyCnfPostGA2SP5=true
	elif  [ $myCnfPostGA2SP5Ver -lt $updateMyCnfPostGA2SP5Ver ];then
		updateMyCnfPostGA2SP5=true
	fi

	if [ -z $myCnfRhPostGA2SP5Ver ];then
		updateMyCnfRhPostGA2SP5=true
	elif [ $myCnfRhPostGA2SP5Ver -lt $updateMyCnfRhPostGA2SP5Ver ];then
		updateMyCnfRhPostGA2SP5=true
	fi
	
	if [ -z $waveCronVer ];then
		updateWaveCron=true
	elif [ $waveCronVer -lt $updateWaveCronVer ];then
		updateWaveCron=true
	fi
	
	if [ -z $internalExecutorVer ];then
		updateInternalExecutor=true
	elif [ $internalExecutorVer -lt $updateInternalExecutorVer ];then
		updateInternalExecutor=true
	fi

	if [ -z $dbRestoreScriptVer ];then
		updateDBRestoreScript=true
	elif [ $dbRestoreScriptVer -lt $updateDbRestoreScriptVer ];then
		updateDBRestoreScript=true
	fi

	if [ -z $WAVEToolsScriptVer ];then
		updateWAVEToolsScript=true
	elif [ $WAVEToolsScriptVer -lt $updateWAVEToolsScriptVer ];then
		updateWAVEToolsScript=true
	fi

	if [ -z $encryptChangerVer ];then
		updateEncryptChanger=true
	elif [ $encryptChangerVer -lt $updateEncryptChangerVer ];then
		updateEncryptChanger=true
	fi
	
	if [ -z $passResetterScriptVer ];then
		updatePassResetterScript=true	
	elif [ $passResetterScriptVer -lt $updatePassResetterScriptVer ];then
		updatePassResetterScript=true		
	fi
	
	if [ -z $networkUpdateVer ];then
		updateNetworkUpdate=true
	elif [ $networkUpdateVer -lt $updateNetworkUpdateVer ];then
		updateNetworkUpdate=true
	fi
	
	if [ -z $packWaveCliVer ];then
		updatePackWaveCLI=true
	elif [ $packWaveCliVer -lt $updatePackWaveCliVer ];then
		updatePackWaveCLI=true
	fi
	
	if [ -z $cliBatVer ];then
		updateCLIBat=true
	elif [ $cliBatVer -lt $updateCliBatVer ];then
		updateCLIBat=true
	fi
	
	if [ -z $cliScrVer ];then
		updateCLIScr=true
	elif [ $cliScrVer -lt $updateCliScrVer ];then
		updateCLIScr=true
	fi
	
	if [ -z $sm191Ver ];then
		updateSM=true
	elif [ $sm191Ver -lt $updateSm191Ver ];then
		updateSM=true
	fi
	
	if [ -z $licVer ];then
		updateLic=true
	elif [ $licVer -lt $updateLicVer ];then
		updateLic=true
	fi
	
	if [ -z $dataCaptureScriptVer ];then
		updateDataCaptureScript=true
	elif [ $dataCaptureScriptVer -lt $updateDataCaptureScriptVer ];then
		updateDataCaptureScript=true
	fi	
	
	if [ -z $specVer ];then
		updateSpecFiles=true
	else
		if [ "$specVer" -lt "$updateSpecVer" ]; then
		#	newestSpecVersion=$(compareVersionStrings "$specVer" "$updateSpecVer")
		#	if [ "$newestSpecVersion" == "$updateSpecVer" ]; then
				updateSpecFiles=true
		#	fi
		fi
	fi

	if [ -z $connectableExitVer ];then
		updateConnectableExit=true
	elif [ $connectableExitVer -lt $updateConnectableExitVer ];then
		updateConnectableExit=true
	fi

	updateList="$updateSM $updateWave  $updateCommon  $updateBackground  $updateDBRestorer $updateWAVETools $updateEncKey  $updateCLI  $updateWebScript  $updateWaveJnlp  $updateBackgroundServices  $updateTestJnlp  $updatePassResetter  $updateTestAPI  $updatePassResetterScript  $updateInternalExecutor  $updateCLIScr  $updateCLIBat  $updateNetworkUpdate  $updateEncryptChanger  $updateDBRestoreScript $updateWAVEToolsScript $updateWaveCron $updateMyCnfRh  $updateMyCnf $updateMyCnfRhPostGA2SP5 $updateMyCnfPostGA2SP5 $updateLogRotate  $updateLoadClc  $updateHttpdRh6  $updateHttpdRh5  $updateHttpd  $ServerConf  $updateVersionScript  $updateWaveSrvIP  $updateExecNotification  $updateStyle  $updateIndex $updateDataCapture $updateDataCaptureScript $updateSpecFiles $updateLic $updateConnectableExit"
		
	for component in $updateList; do
		#echo $component	
		if $component ; then
			update=true	
		fi
	done
}


#Copies Updated jars and files to the installed locations
function update(){
    
	logMessage "Updating files..."

    if $updateJsch ; then
       logMessage "Updating JSCH to a newer version"
       cp --preserve=timestamps -f $runDir/GUI/Common/jsch-0.1.53.jar /usr/wave/GUI/Common/
       chmod 755 /usr/wave/GUI/Common/jsch-0.1.53.jar
       cp --preserve=timestamps -f $runDir/GUI/appl/jsch-0.1.53.jar /usr/wave/GUI/appl/
       chmod 755 /usr/wave/GUI/appl/jsch-0.1.53.jar  
       logMessage "removing the old JSCH version"
       rm -rf /usr/wave/GUI/Common/jsch-0.1.42.jar /usr/wave/GUI/appl/jsch-0.1.42.jar
    fi

    if $updateApacheCommon ; then
	    logMessage "Updating commons-collections to a newer version"
	    cp --preserve=timestamps -f $runDir/GUI/Common/commons-collections-3.2.2.jar /usr/wave/GUI/Common/
	    chmod 755 /usr/wave/GUI/Common/commons-collections-3.2.2.jar
	    logMessage "removing the old commons-collections version"
	    rm -rf /usr/wave/GUI/Common/commons-collections-3.2.jar
    fi

	if $updateWave ; then
		cp --preserve=timestamps -f $updateWaveJar "$waveJarLocale"
		logMessage "Updated Wave Jar"
	fi
	
	if $updateCommon ;then
		cp --preserve=timestamps -f $updateCommonJar $commonJarLocale
  		cp --preserve=timestamps -f $updateCommonJar $BASEDIR/WAVECLI/CGIScript/
		logMessage "Updated Common Jar"
	fi

	if $updateBackground ;then
		cp --preserve=timestamps -f $updateBackgroundJar $backgroundJarLocale
		logMessage "Updated Background Jar"
	fi

	if $updatePassResetter ;then
		cp --preserve=timestamps -f $updatePassResetterJar $passResetterJarLocale
		logMessage "Updated PassResetter Jar"	
	fi
	
	if $updateDBRestorer ;then
		cp --preserve=timestamps -f $updateDBRestoreJar $DBRestoreJarLocale
		logMessage "Updated Wave DB Restore Jar"
	fi

	if $updateWAVETools ;then
		cp --preserve=timestamps -f $updateWAVEToolsJar $WAVEToolsJarLocale
		logMessage "Updated Wave Tools Jar"
	fi

	if $updateEncKey ;then
		cp --preserve=timestamps -f $updateEncKeyJar $encKeyJarLocale
		logMessage "Updated Wave Encyption Key Jar"
	fi

	if $updateCLI ;then
		cp --preserve=timestamps -f $updateWaveCLIJar $waveCLIJarLocale
		cp --preserve=timestamps -f $updateWaveCLIJar $BASEDIR/WAVECLI/CGIScript/
		logMessage "Updated CLI Jar"
	fi
	
	if $updateWebScript ;then		
		cp --preserve=timestamps -f $runDir/GUI/scripts.js $BASEDIR/GUI/
		logMessage "Updated webScript Version"	
	fi
	
	if $updateWaveJnlp ;then
		cp --preserve=timestamps -f $runDir/GUI/WAVE.jnlp $BASEDIR/GUI/
		sed -i s/@@@SERVER_IP@@@/$IP_ADDRESS/g $BASEDIR/GUI/WAVE.jnlp
		logMessage "Updated Wave.jnlp"			
	fi
	
	if $updateBackgroundServices ; then
		cp --preserve=timestamps -f $runDir/WAVEBackground/WAVEBackgroundServices $BASEDIR/WAVEBackground/
		cp --preserve=timestamps -f $runDir/WAVEBackground/WAVEBackgroundServices /etc/init.d/
		logMessage "Updated Background Services"
	fi

	if $updateTestJnlp ; then
		cp --preserve=timestamps -f $runDir/GUI/TestAPI.jnlp $BASEDIR/GUI/
		sed -i s/@@@SERVER_IP@@@/$IP_ADDRESS/g /usr/wave/GUI/TestAPI.jnlp
		logMessage "Updated TestAPIJnlp"	
	fi
	
	if $updateTestAPI ; then
		cp --preserve=timestamps -f $updateTestApiJar $testApiJarLocale
		logMessage "Updated TestAPI Jar"	
	fi

	if $updateIndex ;then
		cp --preserve=timestamps -f $runDir/GUI/index.html $BASEDIR/GUI/	
		logMessage "Updated index.html"	
	fi

	if $updateStyle ;then
		cp --preserve=timestamps -f $runDir/GUI/style.css $BASEDIR/GUI/
		logMessage "Updated style.css"
	fi

	if $updateExecNotification ;then
		cp --preserve=timestamps -f $runDir/GUI/CLI/execNotification.cgi $BASEDIR/GUI/CLI/	
		logMessage "Updated execNotification"
	fi

	if $updateWaveSrvIP ;then
		cp --preserve=timestamps -f $runDir/install/changeWAVESRVIP.sh $BASEDIR/install/
		logMessage "Updated Wavesrv IP changer"
	fi

	if $updateVersionScript ;then
		
		if [ -e $BASEDIR/install/CSL-WAVE-Ver.scr ];then
			mv CSL-WAVE-Ver.scr IBM-Wave-Ver.scr
		fi
		cp --preserve=timestamps -f $runDir/install/IBM-Wave-Ver.scr $BASEDIR/install/	
		logMessage "Updated version script"
	fi

	if $updateServerConf ;then
		cp --preserve=timestamps -f $runDir/install/default-server.conf $BASEDIR/install
		if [ "$distro" == "suse" ];then
			cp -f $runDir/install/default-server.conf /etc/apache2		
			logMessage "moving default-server.conf to /etc/apache2"
			logMessage "Updated default-server-conf (suse)"		
		fi		
	fi	
	
	if $updateHttpd ;then
		cp --preserve=timestamps -f $runDir/install/httpd.conf $BASEDIR/install
		logMessage "Updated httpd.conf"
	fi

	if $updateHttpdRh5 ;then
		cp --preserve=timestamps -f $runDir/install/httpd.conf.rhel5 $BASEDIR/install/
		if [ "$distro" == "rhel" ];then
			if [ "$level" == "5" ];then
				cp --preserve=timestamps -f $runDir/install/httpd.conf.rhel5 /etc/httpd/conf/httpd.conf	
				logMessage "Updated httpd.conf (redhat5)"		
			fi 		
		fi
			
	fi

	if $updateHttpdRh6; then
		cp --preserve=timestamps -f $runDir/install/httpd.conf.rhel6 $BASEDIR/install/
		if [ "$distro" == "rhel" ];then
			if [ "level" == "6" ];then
				cp --preserve=timestamps -f $runDir/install/httpd.conf.rhel6 /etc/httpd/conf/httpd.conf	
				logMessage "Updated httpd.conf (redhat6)"		
			fi		
		fi			
	fi

	if $updateLoadClc; then
		rm  -f $BASEDIR/install/loadCLC.scr
		logMessage "Removed legacy loadCLC"	
	fi

	if $updateLogRotate; then
		cp --preserve=timestamps -f $runDir/install/logrotate.conf $BASEDIR/install/	
		logMessage "Updated logRotate"	
	fi

	# whether or not the old my.cnf should be copied to /etc/. default is yes
	updateMyCnfAtEtc=true

	if $updateMyCnfPostGA2SP5; then
		cp --preserve=timestamps -f $runDir/install/my.cnf$myCnfPostSuffix $BASEDIR/install/
		if [ "$distro" == "suse" ] || ( [ "$distro" == "rhel" ] && [ "$level" == "7" ] ); then
			# if the old my.cnf is already in GA2SP5 level, then we should use the new (PostGA2SP5) files 
			if [ $myCnfAtEtcVer -ge $MY_CNF_GA2_SP5_VER ];then
				cp /etc/my.cnf /etc/my.cnf-$CURRDATE
				cp --preserve=timestamps -f $runDir/install/my.cnf$myCnfPostSuffix /etc/my.cnf
				logMessage "Updated my.cnf Post GA2 SP5"
				# Disable the old files copy to /etc
				updateMyCnfAtEtc=false
			fi
		fi
		
	fi

	if $updateMyCnfRhPostGA2SP5; then
		cp --preserve=timestamps -f $runDir/install/my.cnf.rh$myCnfPostSuffix $BASEDIR/install/
		# if this is RHEL7 then we need to use the suse config file not the .rh
		if [ "$distro" == "rhel" ] && [ "$level" != "7" ];then
			# if the old my.cnf is already in GA2SP5 level, then we should use the new (PostGA2SP5) files 
			if [ $myCnfAtEtcVer -ge $MY_CNF_GA2_SP5_VER ];then
				cp /etc/my.cnf /etc/my.cnf-$CURRDATE
				cp --preserve=timestamps -f $runDir/install/my.cnf.rh$myCnfPostSuffix /etc/my.cnf
				logMessage "Updated my.cnf (redhat) Post GA2 SP5"
				# Disable the old files copy to /etc
				updateMyCnfAtEtc=false
			fi
		fi
	fi

	if $updateMyCnf; then
		cp --preserve=timestamps -f $runDir/install/my.cnf $BASEDIR/install/		
		# if this is SLES or RHEL7 then use my.cnf
		if [ "$distro" == "suse" ] || ( [ "$distro" == "rhel" ] && [ "$level" == "7" ] ); then
			if $updateMyCnfAtEtc; then
				cp /etc/my.cnf /etc/my.cnf-$CURRDATE
				cp --preserve=timestamps -f $runDir/install/my.cnf /etc/
				logMessage "Updated my.cnf"
			fi
		fi
	fi
	
	if $updateMyCnfRh; then
		cp --preserve=timestamps -f $runDir/install/my.cnf.rh $BASEDIR/install/
		# if this is RHEL7 then we need to use the suse config file not the .rh
		if [ "$distro" == "rhel" ] && [ "$level" != "7" ];then
			if $updateMyCnfAtEtc; then
				cp /etc/my.cnf /etc/my.cnf-$CURRDATE
				cp --preserve=timestamps -f $runDir/install/my.cnf.rh /etc/my.cnf
				logMessage "Updated my.cnf (redhat)"
			fi
		fi
			
	fi
	
	if $updateWaveCron; then
		cp --preserve=timestamps -f $runDir/install/WAVE.cron $BASEDIR/install/
		cp --preserve=timestamps -f $runDir/install/WAVE.cron /etc/cron.hourly/
		logMessage "Updated WAVE.cron"	
	fi

	if $updateInternalExecutor; then
		cp --preserve=timestamps -f $runDir/scripts/WAVEInternal.WAVE_Executor $BASEDIR/scripts/
		logMessage "Updated Wave Internal Executor"
	fi

	if $updateDBRestoreScript; then
		cp --preserve=timestamps -f $runDir/WAVEBackground/WAVEDBRestorer $BASEDIR/WAVEBackground/
		logMessage "Updated DB Restore Script"	
	fi 

	if $updateWAVEToolsScript; then
		cp --preserve=timestamps -f $runDir/WAVEBackground/WAVETools $BASEDIR/WAVEBackground/
		logMessage "Updated WAVE Tools Script"	
	fi

	if $updateEncryptChanger; then
		cp --preserve=timestamps -f $runDir/WAVEBackground/WAVEEncryptChanger $BASEDIR/WAVEBackground/	
		logMessage "Updated Encrypt Changer"	
	fi

	if $updatePassResetterScript; then
		cp --preserve=timestamps -f $runDir/WAVEBackground/WAVEPasswordResetter $BASEDIR/WAVEBackground/
		logMessage "Updated Pass Resetter"	
	fi

	if $updateNetworkUpdate; then
		cp --preserve=timestamps -f $runDir/WAVECLI/networkUpdate.scr $BASEDIR/WAVECLI/
		logMessage "Updated networkUpdate script"
	fi
	
	# Case there is other changes in the cli which is not wavecli.bat/ wavecli.scr or wavePack version. ex - the Jar iteself changed.
	if [ $updateCLI ];then
		updatePackWaveCLI=true
	fi
	
	if $updateCLIBat; then
		cp --preserve=timestamps -f $runDir/WAVECLI/wavecli.bat $BASEDIR/WAVECLI/
        updatePackWaveCLI=true
		logMessage "Updated waveCLI.bat"
	fi

	if $updateCLIScr; then
		cp --preserve=timestamps -f $runDir/WAVECLI/wavecli.scr $BASEDIR/WAVECLI/
		updatePackWaveCLI=true
		logMessage "Updated waveCLI.scr"	
	fi
	
	if $updatePackWaveCLI; then
		cp --preserve=timestamps -f $runDir/WAVECLI/packWAVECLI $BASEDIR/WAVECLI/
		 
		  #build WAVECLI
    logMessage "Creating packages for IBM Wave CLI..."
    lastDir=`pwd`
    cd $BASEDIR/WAVECLI
    #remove old .tars and .zips and cgi directory
    rm -f WAVECLI.tar
    rm -f WAVECLI.zip
    rm -rf CGIScript
    logMessage "Creating tar for linux..."
    ./packWAVECLI linux
    logMessage "Creating zip for windows..."
    ./packWAVECLI windows
    logMessage "creating CGI executor"
    tar -xzvf WAVECLI.tar
    mv -f WAVECLI CGIScript
    #make allow execution of the cgi script by selinux. if selinux is not enabled, will produce an error message. 2> /dev/null to hide
    cd $BASEDIR/GUI/CLI
    chcon -t httpd_unconfined_script_exec_t execNotification.cgi 2> /dev/null
    cd "$lastDir"
    
		logMessage "Updated packWAVECLI"	
	fi
	
	if $updateSM; then
	  \rm -rf $BASEDIR/install/WAVECLC
	  \rm -rf $BASEDIR/install/WAVEdisk
		\cp --preserve=timestamps -rf $runDir/install/WAVECLC $BASEDIR/install/
		\cp --preserve=timestamps -rf $runDir/install/WAVEdisk $BASEDIR/install/
		\cp --preserve=timestamps -f $runDir/install/smVer	$BASEDIR/install/
		logMessage "Updated SM REXX files"
	fi
	
	if $updateLic; then
	  \rm -f $BASEDIR/doc/license/*
    	\cp --preserve=timestamps -f $runDir/doc/license/* $BASEDIR/doc/license/	
    	logMessage "Updated License Files"
	fi
	
	if $updateDataCapture;then
		cp --preserve=timestamps -f $updateDataCaptureJar $BASEDIR/WAVEBackground/
		chown waveuser $BASEDIR/WAVEBackground/WAVEDataCapture$NEWVERSION.jar
		chmod 755 $BASEDIR/WAVEBackground/WAVEDataCapture$NEWVERSION.jar		
		logMessage "Updated DataCapture Jar"	
	fi
	
	if $updateDataCaptureScript;then
		cp --preserve=timestamps -f $runDir/WAVEBackground/WAVEDataCapture $BASEDIR/WAVEBackground/
		chown waveuser $BASEDIR/WAVEBackground/WAVEDataCapture
		logMessage "Updated DataCapture Script"	
	fi
	
	if $updateSpecFiles;then
		rpm -i --justdb --force $runDir/install/IBM-Wave-*.upgrade.s390x.rpm
		logMessage "Updated Wave RPM metadata"	
	fi
	
	if $updateConnectableExit;then
		if ! [ -d "$BASEDIR/exit" ]; then
			mkdir -p $BASEDIR/exit
			chmod 755 $BASEDIR/exit
		fi
		cp -p -f $runDir/exit/WaveConnectableGuestsExit.samp $BASEDIR/exit/WaveConnectableGuestsExit.samp
	fi
	
	#chown directory, make sure all files copied over didn't get copied over with root user as owner
	chown -RL waveuser $BASEDIR

	#logrotate.conf file must be owned by root and mode 644 (new requirement of logrotate versions >= 3.8.0)
    chown root $BASEDIR/install/logrotate.conf
    chmod 644 $BASEDIR/install/logrotate.conf

}

#service machine updates using the javaupgrader
function runUpdateJar() {
	if [ "$2" == "-SMUpgrade" ];then
		logMessage "Checking for updates to database and service machines"
	else
		logMessage "Checking for updates to database"
	fi
	
	cp="$waveJarLocale:$commonJarLocale:$backgroundJarLocale:$BASEDIR/GUI/Common/jcommon-serializer-0.2.0.jar:$BASEDIR/GUI/Common/commons-collections-3.2.2.jar:$BASEDIR/GUI/Common/jdom.jar:$BASEDIR/WAVEBackground/commons-dbcp-1.2.2.jar:$BASEDIR/GUI/Common/jsch-0.1.53.jar:$BASEDIR/GUI/Common/commons-pool-1.4.jar:$runDir/WAVE-SP-Upgrader.jar:$BASEDIR/GUI/Common/jcommon-1.0.12.jar:$BASEDIR/WAVEBackground/mariadb-java-client-1.1.1.jar:$BASEDIR/GUI/Common/log4j-1.2.16.jar:$BASEDIR/WAVEBackground/commons-net-2.2.jar"
	returnStdOutToNormal
	java -classpath $cp com.CSL.WAVE.upgrader.main.RunUpgrade "$@"
	updateJarRc=$(echo $?)
	saveAndRedirectStdOutToFileDescriptor
}

# set a service status
function setServiceStatus() {
    service=$1
    action=$2
    if [ "$bootArch" == "sysvinit" ]; then
        /etc/init.d/$service $action
    else
        systemctl $action $service
    fi
    return $?
}
#Restart BTS
function restartBTS () {
	logMessage "Restarting Background Services..."
	setServiceStatus WAVEBackgroundServices start
}
#Restart services
function restartServices () {
	errStatus=0
	
	logMessage "Restarting services"
    getServiceNameForDistro $GENERIC_SRV_NAME_MYSQL_SERVER
	logMessage "Restarting $serviceName..."
	setServiceStatus $serviceName start
	res=`echo $?`
	if [ "$res" != "0" ]; then
		errStatus=8
	fi
	
	getServiceNameForDistro $GENERIC_SRV_NAME_WEB_SERVER
	logMessage "Restarting $serviceName..."
	setServiceStatus $serviceName start
	res=`echo $?`
	if [ "$res" != "0" ]; then
		errStatus=8
	fi
	
	return $errStatus
}
#Creates backup directories and copies current files (and sql dump to there)
function backup() {
	logMessage "Backing up old version files..."
	rm -rf $BACKUP_DIR
	mkdir $BACKUP_DIR
	
	#backup Directory to be used for Database by Jar
	mkdir $BACKUP_DIR/Database
	for dir in $(ls $BASEDIR | grep -v '^backup-' | grep -v '^DBBackup' );do
		cp -pr $BASEDIR/$dir $BACKUP_DIR
		if [[ $? != 0 ]];then
			return 1
		fi	
	done
	return 0
}

function compressBackup() {
	logMessage "Compressing $BACKUP_DIR..."	
	tar -czf $BACKUP_DIR.tar.gz -C $BASEDIR $BACKUP_DIR_NAME	
	rm -rf $BACKUP_DIR
}

#will set the $ROLLBACK_DIR variable to the latest backup of the last level
#also sets $ROLLBACK_VER_INFO, $ROLLBACK_VER, and $ROLLBACK_BUILD to appropriate build info
function setRollbackDir() {
	ROLLBACK_DIR=
	ROLLBACK_FIX_PACK=0
	ROLLBACK_VER=0
	ROLLBACK_BUILD=0
	
	setCurrentVersions
	
	#go through all of the backup archives in the installation directory
	for backupArchive in $(ls -r $BASEDIR | grep '^backup-.*\.tar\.gz$'); do
		backupDir=$BASEDIR/$(echo $backupArchive | sed -r 's/\.[[:alnum:]]+\.[[:alnum:]]+$//')
		
		
		#invalid backup since we can't untar backup archive or can't find WAVEBackground jar
		if ! $(tar -xzf $backupDir.tar.gz -C /usr/wave && \
				ls $backupDir/WAVEBackground/ | grep '^WAVEBackground.*\.jar$' > /dev/null); then 
			logMessage "$backupDir is not a valid backup."
			rm -rf $backupDir 2> /dev/null
			continue
		fi
		
		backupJar="$backupDir/WAVEBackground/$(ls $backupDir/GUI/Common | grep '^WAVECommon.*\.jar$' | tail -n 1)"
		backupVerInfo=$(java -cp $backupJar com.CSL.WAVE.versionInfo.CommonsBuildStringGen -version 2> /dev/null)
		
		#invalid backup since we couldn't get the version
		if [[ $? != 0 ]];then
			logMessage "$backupDir is not a valid backup."
			rm -rf $backupDir
			continue
		fi
		
		#get version and build number
		backupVer=$(echo $backupVerInfo |grep -Eo "Version [0-9]{1,2}\.[0-9]{1,2}\.[0-9]{1,2}" |grep -Eo "[0-9]\.[0-9]\.[0-9]"|tr -d '.')
		backupBuild=$(echo $backupVerInfo |grep -Eo "Build [0-9]{3,5}"| grep -Eo "[0-9]{3,5}")
		
		#test to see if the build and version are valid numbers
		if ! $(expr $backupVer$backupBuild + 1 2> /dev/null > /dev/null); then
			logMessage "$backupDir is not a valid backup"
			rm -rf $backupDir
			continue
		fi
		
		#invalid backup since we don't support version before FixPack 3
		if  (( $backupVer$backupBuild < 110503 ));then
			logMessage $backupVer$backupBuild
			logMessage "$backupDir has a version of IBM Wave before FixPack 3." 
			logMessage "We do not support rollback to versions before FixPack 3."
			logMessage "Please contact your IBM Wave representative for more information."
			rm -rf $backupDir
			continue
		fi
		
		#invalid backup since the backup version is later or the same as the installed version
		if (( $backupVer$backupBuild >= $backgroundVer$backgroundBuild ));then
			logMessage "$backupDir contains a version of IBM Wave later or the same of the installed version."
			rm -rf $backupDir
			continue 
		fi
		
		#finally found a good backup!
		if	(( $backupVer$backupBuild > $ROLLBACK_VER$ROLLBACK_BUILD ));then
			
			if [[ -n $ROLLBACK_DIR ]];then
				rm -rf $ROLLBACK_DIR
			fi
			
			ROLLBACK_DIR=$backupDir
			ROLLBACK_VER=$backupVer
			ROLLBACK_BUILD=$backupBuild
			ROLLBACK_FIX_PACK=$(getFixPackNumber $ROLLBACK_BUILD)
			
		fi
	
	done
	
}

function verifyDBDump() {
	dbDumpFile=$1
	
	for table in ${tables[@]};do
		if ! $(grep -q $table $dbDumpFile);then
			return 8
		fi
	done
}

#rolls back the database, if the database backup file exists in the backup directory
function rollbackDB() {
	if $(find $ROLLBACK_DIR/Database/ -name 'backupSQLDump-*.sql' | grep -q '.'); then
		backupSQLFile=$(find $ROLLBACK_DIR/Database/ -name 'backupSQLDump-*.sql' | tail -n 1)
		
		verifyDBDump $backupSQLFile
		retStatus=$?
		
		if [[ $retStatus != 0 ]] ;then
			logMessage "$dbDumpFile is an invalid database backup.  Aborting..."
		else
			logMessage "Rolling back database using ${backupSQLFile}." 
			cd /usr/wave/WAVEBackground/
			./WAVEDBRestorer $backupSQLFile
			retStatus=$?
		
			cd - >> /dev/null
		fi
		
	else
		logMessage "No database backup file found."
	fi
	
	return $retStatus
	
}

function removeLegacyFiles() {
  OLDVERSION='110'
  OLDVERSIONDOTTED='1.10'
  logMessage "Removing legacy Jars"
  oldWaveJar="$BASEDIR/GUI/appl/WAVE$OLDVERSION.jar"
  oldCommonJar="$BASEDIR/GUI/Common/WAVECommon$OLDVERSION.jar"
  oldBackgroundJar="$BASEDIR/WAVEBackground/WAVEBackground$OLDVERSION.jar"
  oldDBRestoreJar="$BASEDIR/WAVEBackground/WAVEDBRestorer$OLDVERSION.jar"
  oldEncKeyJar="$BASEDIR/WAVEBackground/WAVEEncKeyChanger$OLDVERSION.jar"
  oldWaveCLIJar="$BASEDIR/WAVECLI/WAVECLI$OLDVERSION.jar"
  oldDataCaptureJar="$BASEDIR/WAVEBackground/WAVEDataCapture$OLDVERSION.jar"
  rpm -e --justdb --noscripts IBM-Wave-$OLDVERSIONDOTTED
  if [ -e "$BASEDIR/WAVEBackground/WAVEPasswordReseter" ];then
		  rm -rf "/$BASEDIR/WAVEBackground/WAVEPasswordReseter"
	fi
	
	if [ -e "$BASEDIR/WAVEBackground/PasswordReseter.jar" ];then
		 rm -rf "$BASEDIR/WAVEBackground/PasswordReseter.jar"
	fi
	#remove unnecessary dumps
	if [ -e "$BASEDIR/install/WAVEDBDump.sql" ];then
	  rm -rf "$BASEDIR/install/WAVEDBDump.sql"
	fi
	
	if [ -e "$BASEDIR/install/WAVEDBDump.sql.bak" ];then
	  rm -rf "$BASEDIR/install/WAVEDBDump.sql.bak"
	fi
	
	if [ -e "$oldDataCaptureJar" ];then
	  rm -f "$oldDataCaptureJar"
	fi
	
  rm -f $oldWaveJar
  rm -f $oldCommonJar
  rm -f "$BASEDIR/WAVECLI/CGIScript/WAVECommon$OLDVERSION.jar"
  rm -f $oldBackgroundJar
  rm -f $oldDBRestoreJar
  rm -f $oldEncKeyJar
  rm -f $oldWaveCLIJar
  rm -f "$BASEDIR/WAVECLI/CGIScript/WAVECLI$OLDVERSION.jar"
  
  
}



function rollbackSM() {
	logMessage "Rolling back service machines..."
	cp="$waveJarLocale:$commonJarLocale:$backgroundJarLocale:$BASEDIR/GUI/Common/jcommon-serializer-0.2.0.jar:$BASEDIR/GUI/Common/commons-collections-3.2.2.jar:$BASEDIR/GUI/Common/jdom.jar:$BASEDIR/WAVEBackground/commons-dbcp-1.2.2.jar:$BASEDIR/GUI/Common/jsch-0.1.53.jar:$BASEDIR/GUI/Common/commons-pool-1.4.jar:$runDir/WAVE-SP-Upgrader.jar:$BASEDIR/GUI/Common/jcommon-1.0.12.jar:$BASEDIR/WAVEBackground/mariadb-java-client-1.1.1.jar:$BASEDIR/GUI/Common/log4j-1.2.16.jar:$BASEDIR/WAVEBackground/commons-net-2.2.jar"
	java -classpath $cp com.CSL.WAVE.upgrader.main.RunUpgrade -SMUpgrade
	
	return $?
}


function rollback() {
	if ! restartServices;then
		logMessage "Error starting services."
		return 8
	fi
	
	setRollbackDir
	
	if [[ -z $ROLLBACK_DIR ]]; then
		logMessage "No valid backup found.  Rollback aborted."
		return 5
	fi
	
	logMessage "You will rollback from IBM Wave Version 1.2.0 FixPack $backgroundFixPack to IBM Wave 1.2.0 FixPack $ROLLBACK_FIX_PACK."
	logMessage "The backup archive $ROLLBACK_DIR.tar.gz will be used."
	logMessage "Continue? (y/n)"
	
	while [[ -z $userAns ]];do		
			read userAns
			logToFileOnly $userAns
	done
	if ! [[ $userAns == "y"  ||  $userAns == "Y" || $userAns == "yes" || $userAns == "Yes" ]];then
		return 8
	fi	
	
	rollbackDB
	retStatus=$?
	
	if [[ $retStatus != 0 ]]; then 
		logMessage "Rollback of database failed.  Rollback aborted."
		return $retStatus
	fi
	
	#copy back files
	logMessage "Copying back old installation files..."
	for dir in $(ls $ROLLBACK_DIR | grep -v '^Database$');do
		cp -pr $ROLLBACK_DIR/$dir $BASEDIR/
	done
	cp -p  $BASEDIR/WAVEBackground/WAVEBackgroundServices /etc/init.d
	
	
	rollbackSM
	retStatus=$?
	
	if [[ $retStatus != 0 ]]; then 
		logMessage "Rollback of service machines failed. Rollback aborted."
		return $retStatus
	fi
		
	logMessage "Rollback complete!  You are now at FixPack $ROLLBACK_FIX_PACK."
	logMessage "***NOTE: Please be sure to have all IBM Wave users clear their Java cache before logging in!!***"
			
}
#forcefully set update flags for certain build level dependant components
function forceSetUpdate(){
logMessage "Forcing update..."
updateWave=true ; updateCommon=true ;updateBackground=true;updateDBRestorer=true;updateEncKey=true;updateCLI=true
updatePassResetter=true; updateTestAPI=true; updateEncryptChanger=true;updateSM=true;updateDataCapture=true;
update=true; updateSpecFiles=true;updateWAVETools=true
}

# get a service current status
function getServiceStatus() {
    service=$1
    if [ "$bootArch" == "sysvinit" ]; then
		/etc/init.d/$service status
    else
        srvStatus=`systemctl is-active $service`
        srvRc=$?
        logMessage $service is $srvStatus
    fi
    return $srvRc
}

function setBootArch() {
    if ([ "$distro" == "rhel" ] && [ "$level" == "7" ]) || ([ "$distro" == "suse" ] && [ "$level" == "12" ]); then
        bootArch=systemd
    else
        bootArch=sysvinit
    fi
}

# validate an RPM before applydeltarpm
function validateRPM() {
	rpmFile=$1
	rpmRc=0
	deltarpmFound=`which applydeltarpm &> /dev/null;echo $?`
	# if not a regular file or it does not exists
	if ! [ -f "$rpmFile" ]; then
		logMessage "RPM File not found at $rpmFile..."
		rpmRc=1
	else
		if ([ "$distro" == "rhel" ] && [ "$level" != "7" ]) || ([ "$distro" == "suse" ] && [ "$level" != "12" ]); then
			logMessage "The install option is only valid for RHEL7 and SLES12"
			logMessage "Please install the rpm manually and then doUpdate.sh again without the install option"
			rpmRc=1
		else
			rpmInstallStatus=`rpm -q IBM-Wave | grep IBM-Wave-`
			if ! [ -z "$rpmInstallStatus" ]; then
				logMessage "IBM Wave is already installed on this system..."
				rpmRc=1
			elif [ "$deltarpmFound" != "0" ]; then
				logMessage "Unable to find the applydeltarpm command..."
				logMessage "Please make sure you have it installed and retry the operation"
				rpmRc=1
			else
				rpmFileMd5=`md5sum $rpmFile | cut -d" " -f1`
				if [ "$GA2_SP0_RPM_MD5" != "$rpmFileMd5" ]; then
					logMessage "RPM hash verification failed..."
					logMessage "Please make sure you have the original IBM Wave RPM file specified"
					rpmRc=1
				else
					logMessage "RPM verification passed..."
				fi
			fi
		fi
	fi
	return $rpmRc
}

# apply delta rpm, create a new one and install it
function applyAndInstallRPM() {
	logMessage "Installing IBM Wave..."
	installRc=0
	rpmFile=$1
	deltaRPMPath=$runDir/install/$deltaRPMName
	applydeltarpm -r $rpmFile $deltaRPMPath $newRPMPath
	if [ "$?" == "0" ] && [ -f "$newRPMPath" ]; then
		rpm -i $newRPMPath
		rpmInstallStatus=`rpm -q IBM-Wave | grep IBM-Wave-`
		rm $newRPMPath
			if [ -z "$rpmInstallStatus" ]; then
				logMessage "IBM Wave failed to install..."
				installRc=1
			fi
	else
		installRc=1
	fi
	return $installRc
}
function changeWaveUserStatus(){
	# Build username
	LETTERS='abcdefghijklmnopqrstuvwxyz1234567890'
	USER=''
	USER=$USER`echo $LETTERS|cut -b23-23``echo $LETTERS|cut -b1-1`
	USER=$USER`echo $LETTERS|cut -b22-22``echo $LETTERS|cut -b5-5`
	USER=$USER`echo $LETTERS|cut -b21-21``echo $LETTERS|cut -b19-19`
	USER=$USER`echo $LETTERS|cut -b5-5``echo $LETTERS|cut -b18-18`
	#check if internal user is locked (disallow password login)
	isLocked=`passwd -S $USER | cut -d' ' -f2 | egrep -wc 'LK|L'`
	if [ "$isLocked" == "0" ]; then
		logMessage "Locking internal user."
 	    passwd -d $USER
		passwd -l $USER
 	else
		logMessage "Internal user already locked."
	fi
}




function exitFail(){
			 logMessage "---------------------------------------------"
			 logMessage "|                                           |"
			 logMessage "|       IBM Wave Failed to Update!          |"
			 logMessage "|                                           |"
		 	 logMessage "---------------------------------------------"	
	exit $1
}
###############################################################################
# start to run the main doUpdate ##############################################
###############################################################################

#Check that the linux user running the install is root
if [[ $EUID -ne 0 ]]; then
   logMessage "This script must be run as root" 
   exit 8
fi

shouldRollback=false
#parse arguments
argIndex=0
while [ "$argIndex" -lt "$#" ]; do
		#increment index
        argIndex=$((argIndex+1))
		#get the variable value at the Index
        var=`eval echo '$'$argIndex`
        case "$var" in
          "-f"|"-force"|"--force")
              forceSetUpdate
              ;;
          "-i"|"-install"|"--install")
                argIndex=$((argIndex+1))
                if [ "$argIndex" -le "$#" ]; then
                        rpm=`eval echo '$'$argIndex`
                        logMessage "Validating RPM <$rpm>..."
						validateRPM $rpm
						if [ "$?" == "0" ]; then
							shouldInstallRPM=true
						else
							exit 8
						fi
                else
                        logMessage "Missing RPM Path..."
                        exit 8
                fi
              ;;
				"-tmpDir"|"--tmpDir")
				argIndex=$((argIndex+1))
				if [ "$argIndex" -le "$#" ]; then
					tmpDir=`eval echo '$'$argIndex`
					if ! [ -d "$tmpDir" ]; then
						logMessage "$tmpDir does not exist..."
						exit 8
					fi
					if ! [ -r "$tmpDir" ] || ! [ -w "$tmpDir" ] || ! [ -x "$tmpDir" ]; then
						logMessage "User must have rwx permissions for temporary directory $tmpDir ..."
						exit 8
					fi
				else
					logMessage "Missing temporary Path..."
					exit 8
				fi
				;;
#               "-rollback")
#                       shouldRollback=true
#                       ;;
                *)
                        logMessage "Invalid argument"
                        exit 8
                        ;;
esac
done

#install RPM if needed and go on if passed ok
if [ "$shouldInstallRPM" == "true" ]; then
	applyAndInstallRPM $rpm
	if [ "$?" != "0" ]; then
		logMessage  "Aborting doUpdate..."
		exit 8
	fi
fi

setBootArch
logMessage "Stopping IBM Wave Background Services..."
setServiceStatus WAVEBackgroundServices stop
statusSuSE=$(/etc/init.d/WAVEBackgroundServices status|grep -o "not active")
statusRhel=$(/etc/init.d/WAVEBackgroundServices status|grep -o "not found")
statusDead=$(/etc/init.d/WAVEBackgroundServices status |grep -o "dead")


#rollback the system if user inputs flag
if $shouldRollback; then
		
	if [ "$statusSuSE" == "not active" ] || 
		[ "$statusRhel" == "not found" ] || 
		[ "$statusDead" == "dead" ];then
		rollback
		retStatus=$?
		
		if [[ -n $ROLLBACK_DIR ]];then
			rm -rf $ROLLBACK_DIR
		fi
		
		restartBTS
	else
		logMessage "Failed stopping WAVEBackgroundServices, exiting.."
		exit 1	
	fi
		
	exit $retStatus		
fi

getServiceNameForDistro $GENERIC_SRV_NAME_MYSQL_SERVER
getServiceStatus $serviceName
res=`echo $?`
if [ "$res" == "0" ]; then
    setServiceStatus $serviceName stop
    getServiceStatus $serviceName
	res=`echo $?`
    if [ "$res" == "0" ]; then
        logMessage "Failed stopping $serviceName"
        exit 8
    fi
fi

getServiceNameForDistro $GENERIC_SRV_NAME_WEB_SERVER
getServiceStatus $serviceName
res=`echo $?`
if [ "$res" == "0" ]; then
    setServiceStatus $serviceName stop
    getServiceStatus $serviceName
	res=`echo $?`
    if [ "$res" == "0" ]; then
        logMessage "Failed stopping $serviceName"
        exit 8
    fi
fi

	
if [ "$statusSuSE" == "not active" ] || [ "$statusRhel" == "not found" ] || [ "$statusDead" == "dead" ];then
	
	if ! backup;then
		exitFail 10
	fi	
	logMessage "Checking levels and updates..."
	queryRpmSetMigrationFlag
	#set update versions regardless if migrating or not, update versions are always going to be 1.2.0. Vars set here are used for copying 
	#new jars over to existing directory
	setUpdateVersions
	#if migrating, automatically set all updates to true. And set the locales for new 1.2.0 jars when copying so we copy to the new
	#120 jar name, and not the 110 jar name
	if $migration ;then
	  logMessage "Enabling migration from legacy GA1 to GA2"
	  updateWave=true ; updateCommon=true ;updateBackground=true;updateDBRestorer=true;updateEncKey=true;updateCLI=true
updateWebScript=true;updateWaveJnlp=true;updateBackgroundServices=true;updateTestJnlp=true;updatePassResetter=true
updateTestAPI=true;updateIndex=true;updateStyle=true;updateExecNotification=true;updateWaveSrvIP=true;updateVersionScript=true
updateServerConf=true;updateHttpd=true;updateHttpdRh5=true;updateHttpdRh6=true;updateLoadClc=true;updateLogRotate=true;updateMyCnf=true
updateMyCnfRh=true;updateWaveCron=true;updateInternalExecutor=true;updateDBRestoreScript=true;updateEncryptChanger=true;updatePassResetterScript=true
updateNetworkUpdate=true;updatePackWaveCLI=true;updateCLIBat=true;updateCLIScr=true;updateSM=true;updateDataCapture=true;updateDataCaptureScript=true
updateLic=true;migration=true;
updateSpecFiles=true
updateMyCnfPostGA2SP5=true
updateMyCnfRhPostGA2SP5=true
updateWAVETools=true
updateWAVEToolsScript=true
update=true

  waveJarLocale="$BASEDIR/GUI/appl/WAVE$NEWVERSION.jar"
  commonJarLocale="$BASEDIR/GUI/Common/WAVECommon$NEWVERSION.jar"
  backgroundJarLocale="$BASEDIR/WAVEBackground/WAVEBackground$NEWVERSION.jar"
  testApiJarLocale="$BASEDIR/GUI/TestAPI/TestAppl.jar"
  DBRestoreJarLocale="$BASEDIR/WAVEBackground/WAVEDBRestorer$NEWVERSION.jar"
  encKeyJarLocale="$BASEDIR/WAVEBackground/WAVEEncKeyChanger$NEWVERSION.jar"
  waveCLIJarLocale="$BASEDIR/WAVECLI/WAVECLI$NEWVERSION.jar"
  passResetterJarLocale="$BASEDIR/WAVEBackground/PasswordResetter.jar"
 
  removeLegacyFiles
  
	else	  
	  setCurrentVersions
	  
	fi
	
	#lock the waveuser if needed
	changeWaveUserStatus
	
	#This calls the compareVersions function which checks the version of the common jars to check if we need to update any of them
	  compareVersions
		
	if $update ;then
		update
		restartServices
		sleep 5
		#After the new jars are updated, including the new password resetter jar, if the migration flag is set, 
		#run the password resetter to expire user passwords					
	else
		logMessage "Nothing needed to update"
		restartServices		
		sleep 5	
	fi
	buildArgs="-DBUpgrade"
	if $updateSM;then
		logMessage "There are newly added rexx files, it is recommended to populate the service machines with these files."
		buildArgs="$buildArgs -SMUpgrade"	
	fi
	
	## populating the waveservice machines
	if ! $updateSM && ! $shouldInstallRPM;then
		logMessage "Would you like to re-populate the Wave Service Machines? (y/n)"
		while [ -z $userAns ];do		
			read userAns
			logToFileOnly $userAns
		done
		if [ $userAns == "y" ] || [ $userAns == "Y" ] || [ $userAns == "yes" ] || [ $userAns == "Yes" ];then
		  buildArgs="$buildArgs -SMUpgrade"	
		fi	
	fi
	
	if $migration; then
	  buildArgs="$buildArgs -migration"
	fi  
	#add arguments to for sp-upgrader to write to the same log file, and backup to the same direcory
 	buildArgs="$buildArgs -LogFile=$logFile -backupDir=$BACKUP_DIR -distro=$dbDistro$level-$arch"
	if ! [ -z "$tmpDir" ]; then
		buildArgs="$buildArgs -tmpDir=$tmpDir"
	fi
	logMessage "buildArgs: $buildArgs"
	runUpdateJar $buildArgs
	
	#check return code of update jar
	if [ $updateJarRc -ne 0 ];then
		    case $updateJarRc in
		    10)
		     logMessage "There was a problem checking or updating the IBM Wave database, please check the console for errors and re-run the Updater"
		     ;;
		    12)
		     logMessage "There was a problem backing up the current waveDB, please check the console for errors and re-run the Updater"	
		      ;;
		    20)
		     logMessage "There was a problem populating IBM Wave service machines, please check the console for errors and re-run the Updater"
		      ;;		    		      
		    50)
		     logMessage "There was an error migrating legacy report templates, please check the console for errors and call service"
		     ;;
		    *)
		      logMessage "There was a problem checking or updating the IBM Wave database and service machines, please check the console for errors and re-run the Updater RC: $updateJarRc"
		      ;;
		    esac  
			exitFail $updateJarRc 
	fi
	
	
	
	
	
	if $migration;then
		  logMessage "Expiring user passwords that do not comply with minimum security standards"
		  returnStdOutToNormal
		  /usr/wave/WAVEBackground/WAVEPasswordResetter -e
		  rc=$?
		  saveAndRedirectStdOutToFileDescriptor
		  if [ $rc -ne 0 ];then
		    case $rc in
		    1)
		     logMessage "Invalid User Input"
		     ;;
		    2)
		     logMessage "Error connecting to db"
		      ;;
		    3)
		      logMessage "Error Connecting to BTS"
		      ;;		      
		    4)
		     logMessage "Error issuing SQL query"
		     ;;
		    5)
		     logMessage "Error writing to log file"
		     ;;
		    6)
		     logMessage "Error validating security context"
		     ;;
		    7)
		      logMessage "User Aborted!"
		      ;;
		    8)
		      logMessage "General error ocurred"
		      ;;
		    *)
		      logMessage "RC: $rc"  
		      ;;
		    esac  
		      logMessage "An error ocurred when migrating to IBM Wave for z/VM 1.2. Please check the console or $logFile for details, and contact IBM  Wave Service"
		     	exit $rc 
		  fi
		  
		fi	
	
	restartBTS
	
	compressBackup
		logMessage "---------------------------------------------"
		logMessage "|                                           |"
		logMessage "|       IBM Wave Successfully Updated!      |"
		logMessage "|                                           |"
		logMessage "---------------------------------------------"	
else
	logMessage "Failed stopping WAVEBackgroundServices, exiting.."
	exit 1
fi

