UPDATE `WAVE`.`WAVE_Parameter_Table` SET `Parameter_Value`='1.2.0.0' WHERE `Parameter_Name`='WAVEDB_Version';
UPDATE `WAVE`.`WAVE_Parameter_Table` SET `Parameter_Value`='1.2.0' WHERE `Parameter_Name`='BTS_PARM_Version';
CREATE TABLE `WAVE`.`WAVE_Report_Template_Table` (
  `Report_DB_ID` INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  `Report_Template_Name` VARCHAR(255) NOT NULL,
  `Report_Template_Type` VARCHAR(45) NOT NULL,
  `Report_Template_Description` TEXT NOT NULL,
  `Report_Template_Width` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `Report_Template_Height` INTEGER UNSIGNED NOT NULL DEFAULT 0,
  `Report_Template_Privacy` TINYINT UNSIGNED NOT NULL DEFAULT 0,
  `Report_Template_Create_By` VARCHAR(255) NOT NULL,
  `Report_Template_Create_On` DATETIME NOT NULL DEFAULT '2000-01-01 00:00:00',
  `Report_Template_Modified_By` VARCHAR(255) NOT NULL,
  `Report_Template_Modified_On` DATETIME NOT NULL DEFAULT '2000-01-01 00:00:00',
  `Report_Template_Locker` VARCHAR(255) NOT NULL,
  `Report_Template_IAN` TEXT NOT NULL,
  `Report_Template_Column_Properties` LONGTEXT NOT NULL,
  `Report_Template_Sort_Column` INTEGER UNSIGNED NOT NULL,
  `Report_Template_Sort_Order` TINYINT UNSIGNED NOT NULL,
  `Report_Template_Filter_Properties` TEXT NOT NULL,
  PRIMARY KEY (`Report_DB_ID`),
  INDEX `Index_Create`(`Report_Template_Create_By`),
  INDEX `Index_Modify`(`Report_Template_Modified_By`),
  CONSTRAINT `FK_Report_Template_Table_1` FOREIGN KEY `FK_Report_Template_Table_1` (`Report_Template_Create_By`)
    REFERENCES `WAVE_User_Table` (`WAVE_User_Name`)
    ON DELETE CASCADE
    ON UPDATE CASCADE,
  CONSTRAINT `FK_Report_Template_Table_2` FOREIGN KEY `FK_Report_Template_Table_2` (`Report_Template_Modified_By`)
    REFERENCES `WAVE_User_Table` (`WAVE_User_Name`)
    ON DELETE CASCADE
    ON UPDATE CASCADE
)
TYPE = InnoDB;
insert into WAVE_External_Call_Messages values
('WAVESQL67000I', 'ConnectionToSQLReports', '*GENERAL*', 0, 0, 90, 90),
('WAVESQL67001I', 'ConnectionToSQLReports', '*GENERAL*', 0, 4, 90, 90),
('WAVESQL67002I', 'ConnectionToSQLReports', '*GENERAL*', 0, 8, 90, 90),
('WAVESQL67003I', 'ConnectionToSQLReports', '*GENERAL*', 0, 12, 90, 90),
('WAVESQL67004W', 'ConnectionToSQLReports', '*GENERAL*', 4, 0, 91, 91),
('WAVESQL67005W', 'ConnectionToSQLReports', '*GENERAL*', 4, 4, 92, 92),
('WAVESQL67006W', 'ConnectionToSQLReports', '*GENERAL*', 4, 8, 93, 93),
('WAVESQL67007W', 'ConnectionToSQLReports', '*GENERAL*', 4, 12, 94, 94),
('WAVESQL67008E', 'ConnectionToSQLReports', '*GENERAL*', 8, 0, 95, 95),
('WAVESQL67009E', 'ConnectionToSQLReports', '*GENERAL*', 8, 4, 96, 96),
('WAVESQL67010E', 'ConnectionToSQLReports', '*GENERAL*', 8, 8, 97, 97),
('WAVESQL67011E', 'ConnectionToSQLReports', '*GENERAL*', 8, 12, 98, 98);
INSERT INTO `WAVE`.`OS_Distribution_Table` (`Distribution_ID`, `Distribution_Short_Name`, `Distribution_Full_Name`, `Distribution_Discription`, `Distribution_Update_User`, `Distribution_Arch`) VALUES ('9', 'SLES12-64b', 'SLES12 - 64 Bit', 'SuSE 12 64Bit Enterprise Server Edition', 'WAVEinit', '64');
INSERT INTO `WAVE`.`OS_Distribution_Table` (`Distribution_ID`, `Distribution_Short_Name`, `Distribution_Full_Name`, `Distribution_Discription`, `Distribution_Update_User`, `Distribution_Arch`) VALUES ('10', 'RHEL7-64b', 'RedHat 7 - 64 Bit', 'RedHat 7 64Bit Enterprise Linux', 'WAVEinit', '64');
INSERT INTO WAVE_Messages VALUES ('WAVREP004I', 'I',1,'IBM Wave Report @p@ was exported successfully to @p@.','The specified IBM Wave Report was exported successfully.');
UPDATE `WAVE`.`VM_User_Common_Table` SET `VM_User_IsInitedForWAVE`=`VM_User_IsInitedForWAVE` & ~512;
UPDATE WAVE_Messages SET WAVE_Message_Description = 'The specified IBM Wave Report was updated successfully.' WHERE WAVE_Message_Code='WAVREP003I';
UPDATE WAVE_Messages SET WAVE_Message_Description = 'The specified report was deleted successfully.  If the deleted report is a global report, this change will be reflected in other Wave User sessions.' where WAVE_Message_Code = 'WAVREP002I';
UPDATE `WAVE`.`VM_User_Common_Table` SET `VM_User_IsInitedForWAVE`=`VM_User_IsInitedForWAVE` | 16384 WHERE VM_User_IsInitedForWAVE <> '1' and (VM_User_Distribution_Id = '3' or VM_User_Distribution_Id = '8' or VM_User_Distribution_Id = '6' or VM_User_Distribution_Id = '7');